//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSandyBrown
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property strict


//
//
//
//
//

extern ENUM_APPLIED_PRICE Price   = PRICE_MEDIAN; // Price to use
extern int                Length  = 25;           // Inverse of driving coefficient
extern int                Damping =  5;           // Smoothing percent
extern int                MaxGap  = 30;           // Maximum gap ignored (pips)
extern int                Shift   =  0;           // Shift

double mma[];
double mmada[];
double mmadb[];
double trend[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,mma);   SetIndexShift(0,Shift);
   SetIndexBuffer(1,mmada); SetIndexShift(1,Shift);
   SetIndexBuffer(2,mmadb); SetIndexShift(2,Shift);
   SetIndexBuffer(3,trend);
   IndicatorShortName ("Moris MMA ("+(string)Length+", "+(string)Damping+", "+(string)MaxGap+", "+(string)Shift+")");    
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
   double GapLimit = MaxGap*Point*MathPow(10,MathMod(Digits,2));

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,mmada,mmadb);
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (r>0)
         {         
            double y1 = work[r-1][_y1];
            double y2 = work[r-1][_y2];
         
            if ((High[i]<Low[i+1]) || (Low[i]>High[i+1]))
            {
               double gap = work[r][_price]-work[r-1][_price];
   	      		if (MathAbs(gap)>GapLimit)
                  {
                     y1 = mma[i+1]+gap;
                     y2 = mma[i+2]+gap;
                  }
            }            
            
            double noise  = MathMax(High[i]-Low[i],0.000001);
            double err    = (work[r][_price]-2.0*y1+y2)/noise; 
            double drv    = MathMax(MathMin((1.0/Length)*err*err+(1.0/Length)*MathAbs(err),0.5),0.0);
            double dmp    = MathMax(MathMin((1.0/Length)*MathAbs(y1-y2)/noise + Damping/100.0,1.0),0.0);
         
            //
            //
            //
            //
            //
         
            mma[i]       = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
            work[r][_y1] = mma[i];
            work[r][_y2] = y1;

            trend[i] = trend[i+1];      
            mmada[i] = EMPTY_VALUE;
            mmadb[i] = EMPTY_VALUE;
               if (mma[i] > mma[i+1]) trend[i] = 1;
               if (mma[i] < mma[i+1]) trend[i] =-1;
               if (trend[i]==-1) PlotPoint(i,mmada,mmadb,mma);

         }
   }   
   return(0);           
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}